<script>
  import { afterUpdate } from 'svelte';
  const WARMUP_ROUNDS = 4;

  const A1 = ["Mandatory", "Open-architected", "Re-engineered", "Realigned", "Optimized", "Organized", "Advanced",
    "Multi-tiered", "Switchable", "Focused", "Self-enabling", "Stand-alone", "Virtual", "Enhanced", "Enterprise-wide",
    "Optional", "Versatile", "Profit-focused", "Adaptive", "Object-based", "Diverse", "Expanded", "Front-line",
    "Visionary", "Upgradable", "Exclusive"]; // length = 27

  const A2 = ["bi-directional", "grid-enabled", "system-worthy", "uniform", "5th generation", "coherent", "optimal",
    "zero administration", "systematic", "dedicated", "static", "eco-centric", "dynamic", "homogeneous", "high-level",
    "multi-state", "foreground", "web-enabled", "radical", "next generation", "encompassing", "stable", "real-time",
    "didactic", "bifurcated", "scalable", "needs-based"]; // length = 26

  const A3 = ["strategy", "firmware", "encryption", "throughput", "projection", "Graphical User Interface", "array",
    "adapter", "framework", "open system", "functionalities", "methodology", "instruction set", "collaboration",
    "infrastructure", "orchestration", "core", "intranet", "parallelism", "hierarchy", "challenge", "extranet",
    "software", "budgetary management", "flexibility"]; // length = 23

  const grabFrom = (arr) => arr[Math.floor(Math.random() * arr.length)];

  let currId = 1;

  const createData = (count) => {
    const data = new Array(count);

    for (let i = 0; i < count; i++) {
      data[i] = {
        id: currId++,
        phrase: `${grabFrom(A1)} ${grabFrom(A2)} ${grabFrom(A3)}`,
      };
    }

    return data;
  };

  let data = [];
  let done = false;

  const initialize = () => data = createData(1000);

  const create1K = () => {
    // warmup rounds
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = createData(1000);
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const create2K = () => {
    // warmup rounds
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = createData(2000);
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const create5K = () => {
    // warmup rounds
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = createData(5000);
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const create10K = () => {
    const newData = createData(10000);
    performance.mark("benchmark_start");
    data = newData;
  };

  const create25K = () => {
    const newData = createData(25000);
    performance.mark("benchmark_start");
    data = newData;
  };

  const updateEvery10th = () => {
    if (data.length < 1000) throw new Error('Not initialized');
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = data.slice(0);
      for (let i = 0; i < newData.length; i += 10) {
        const {id, phrase} = newData[i];
        newData[i] = {id, phrase: phrase + ` (u${w + 1})`};
      }
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const swapTwo = () => {
    if (data.length < 1000) throw new Error('Not initialized');
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = [data[0], data[998], ...data.slice(2, 998), data[1], data[999]];
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const deleteOne = () => {
    if (data.length < 1000) throw new Error('Not initialized');
    for (let w = 0; w < WARMUP_ROUNDS + 1; w++) {
      const newData = [...data.slice(0, 499), ...data.slice(500)];
      if (w === WARMUP_ROUNDS) performance.mark("benchmark_start");
      data = newData;
    }
  };

  const deleteEveryThird = () => {
    if (data.length < 1000) throw new Error('Not initialized');
    const newData = [...data].filter((r, i) => i % 3 !== 0);
    performance.mark("benchmark_start");
    data = newData;
  };

  const deleteAll = () => {
    performance.mark("benchmark_start");
    data = [];
  };

  afterUpdate(() => {
    if (!performance.getEntriesByName("benchmark_start").length) return;
    performance.mark("benchmark_end");
    const measure = performance.measure("benchmark", "benchmark_start", "benchmark_end");
    console.log(measure);
    done = true;
  });

</script>

<button id="initialize" on:click={initialize}>Initialize</button>
<button id="create1K" on:click={create1K}>Create 1.000</button>
<button id="create2K" on:click={create2K}>Create 2.000</button>
<button id="create5K" on:click={create5K}>Create 5.000</button>
<button id="create10K" on:click={create10K}>Create 10.000</button>
<button id="create25K" on:click={create25K}>Create 25.000</button>
<button id="updateEvery10th" on:click={updateEvery10th}>Update every 10th</button>
<button id="swapTwo" on:click={swapTwo}>Swap two</button>
<button id="deleteOne" on:click={deleteOne}>Delete one</button>
<button id="deleteEvery3rd" on:click={deleteEveryThird}>Delete every 3rd</button>
<button id="deleteAll" on:click={deleteAll}>Delete all</button>
{#if done}
  <span id="isDone">Done</span>
{/if}
<table>
  <thead>
    <tr>
      <th>ID</th>
      <th>Phrase</th>
    </tr>
  </thead>
  <tbody>
  {#each data as { id, phrase } (id)}
    <tr>
      <td>{id}</td>
      <td>{phrase}</td>
    </tr>
  {/each}
  </tbody>
</table>